#include <windows.h>
#include "TWinControl.h"
#include "TMainForm.h"

static DWORD dwLastWriteError = ERROR_SUCCESS;

#pragma region ZpoilerAL
static const DWORD JUMP_TARGET = 0x005D54CC;// back to original code

__declspec(naked) void SaveLastError() {
	__asm {
		cmp  dword ptr [esp], 0x0052EBDA// caller is TSSGActionListner::OnSubjectDisabled
		push eax

		mov  eax, ERROR_INVALID_FLAGS
		je   DISABLED
		call GetLastError

	DISABLED:
		mov  dwLastWriteError, eax

		pop  eax
		jmp  JUMP_TARGET
	}
}

__declspec(naked) void __fastcall CheckShowMessage(const char* Message) {
	// incompatible for Borland...
	__asm {
		push eax

		push 19
		push 0x00602DE0// "Not Defined Error!"
		push eax
		call strncmp
		add  esp, 12
		test eax, eax
		jnz  SHOW

		pop  eax
	SHOW:
		pop  eax
		or   ecx, -1
		or   edx, -1
		ret
	}
}
#pragma endregion

__declspec(naked) void __cdecl TProcessCtrl_Write_GetLastError()
{
	__asm
	{
		pop     edi
		pop     esi
		pop     ebx
		pop     ebp
		test    eax, eax
		jz      L1
		push    eax
		call    GetLastError
		mov     dword ptr[dwLastWriteError], eax
		pop     eax
	L1 :
		ret
	}
}

void __cdecl ShowLastWriteError()
{
	#define lpApplicationTitle (LPCSTR)0x006020D8
	#define lpNotDefinedError  (LPCSTR)0x00602DE0

	char   lpBuffer[256];
	LPCSTR lpText;

	if (dwLastWriteError != ERROR_SUCCESS)
	{
		FormatMessageA(
			FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_ARGUMENT_ARRAY,
			NULL,
			dwLastWriteError,
			LANG_USER_DEFAULT,
			lpBuffer,
			_countof(lpBuffer) - 1,
			NULL);
		lpText = lpBuffer;
	}
	else
	{
		lpText = lpNotDefinedError;
	}
	MessageBoxA(TWinControl_GetHandle(MainForm), lpText, lpApplicationTitle, MB_ICONERROR);

	#undef lpApplicationTitle
	#undef lpNotDefinedError
}
